#!/usr/bin/perl
#use lib '/home/luholm/mpidali4/';
use strict;
use mpidali;
use warnings;
use 5.010;
use Getopt::Long qw(GetOptions);

my $DALIDATDIR_1="./DAT/";
my $DALIDATDIR_2="./DAT/";
my $JOBID="test";
my $TITLE="test";
my $NPARA=1;
my $DOWOLF=1;
my $DOPARSI=1;

my $USAGE="Compare each query structure against all target structures. Report structural aligments with a Z-score above 2.\n\nUSAGE: $0 [OPTIONS] query.list target.list\n\nOPTIONS:\n --dat1 PATH\tpath to directory containing query data\n --dat2 PATH\tpath to directory containing target data\n --np N    \tnumber of processes if using openmpi\n\nPDB structure data must be imported beforehand using import.pl\n";

GetOptions(
	'dat1=s' => \$DALIDATDIR_1,
	'dat2=s' => \$DALIDATDIR_1,
	'np=i' => \$NPARA,
	'jobid=s' => \$JOBID,
	'title=s' => \$TITLE,
	'wolf=i' => \$DOWOLF,
	'parsi=i' => \$DOPARSI
);
if($#ARGV<1) { die $USAGE; }  
my($list1file,$list2file)=@ARGV;

# lock directory
&lock();

# pslit list1 to soap/wolf
my $soaplist1='soaplist1';
my $wolflist1='wolflist1';
my(@list)=&split_list1($list1file,$DALIDATDIR_1,$soaplist1,$wolflist1);

# soap if needed
if(-s $soaplist1 > 1 && $DOWOLF > 0) {
	system("cp $soaplist1 list1 ; cp $list2file list2");
	&wolf('SOAP',$NPARA,$DALIDATDIR_1,$DALIDATDIR_2,0);
}
if(-s $wolflist1 > 1) {
	system("cp $wolflist1 list1 ; cp $list2file list2");
	if($DOWOLF > 0 ) { &wolf('WOLF',$NPARA,$DALIDATDIR_1,$DALIDATDIR_2,0); }
	if($DOPARSI > 0 ) { &parsi($NPARA,$DALIDATDIR_1,$DALIDATDIR_2,0); }
	&swaplist12();
	if($DOWOLF > 0 ) { &wolf('WOLF',$NPARA,$DALIDATDIR_2,$DALIDATDIR_1,2); }
        if($DOPARSI > 0 ) { &parsi($NPARA,$DALIDATDIR_2,$DALIDATDIR_1,2); }
  	&swaplist12();
}
# output HTML
&FSSP_output($list2file,$DALIDATDIR_1,$DALIDATDIR_2,$JOBID,$TITLE,@list);

# unlock directory
&unlock();       
 
exit();

